Loading...
Searching...
No Matches
pcl::IntegralImage2D< DataType, 1 > Class Template Reference

partial template specialization for integral images with just one channel. More...

`#include <pcl/features/integral_image2D.h>`

## Public Types

using | Ptr = shared_ptr< IntegralImage2D< DataType, 1 > >
using | ConstPtr = shared_ptr< const IntegralImage2D< DataType, 1 > >
using | ElementType = typename IntegralImageTypeTraits< DataType >::IntegralType
using | SecondOrderType = typename IntegralImageTypeTraits< DataType >::IntegralType

## Public Member Functions

| IntegralImage2D (bool compute_second_order_integral_images)
| Constructor for an Integral Image.
virtual | ~IntegralImage2D ()=default
| Destructor.
void | setInput (const DataType *data, unsigned width, unsigned height, unsigned element_stride, unsigned row_stride)
| Set the input data to compute the integral image for.
ElementType | getFirstOrderSum (unsigned start_x, unsigned start_y, unsigned width, unsigned height) const
| Compute the first order sum within a given rectangle.
ElementType | getFirstOrderSumSE (unsigned start_x, unsigned start_y, unsigned end_x, unsigned end_y) const
| Compute the first order sum within a given rectangle.
SecondOrderType | getSecondOrderSum (unsigned start_x, unsigned start_y, unsigned width, unsigned height) const
| Compute the second order sum within a given rectangle.
SecondOrderType | getSecondOrderSumSE (unsigned start_x, unsigned start_y, unsigned end_x, unsigned end_y) const
| Compute the second order sum within a given rectangle.
unsigned | getFiniteElementsCount (unsigned start_x, unsigned start_y, unsigned width, unsigned height) const
| Compute the number of finite elements within a given rectangle.
unsigned | getFiniteElementsCountSE (unsigned start_x, unsigned start_y, unsigned end_x, unsigned end_y) const
| Compute the number of finite elements within a given rectangle.

## Static Public Attributes

static const unsigned | second_order_size = 1

## Detailed Description

template<class DataType>
class pcl::IntegralImage2D< DataType, 1 >

partial template specialization for integral images with just one channel.

Definition at line 232 of file integral_image2D.h.

## Member Typedef Documentation

## ConstPtr

template<class DataType >

using pcl::IntegralImage2D< DataType, 1 >::ConstPtr = shared_ptr<const IntegralImage2D<DataType, 1> >

Definition at line 236 of file integral_image2D.h.

## ElementType

template<class DataType >

using pcl::IntegralImage2D< DataType, 1 >::ElementType = typename IntegralImageTypeTraits<DataType>::IntegralType

Definition at line 239 of file integral_image2D.h.

## Ptr

template<class DataType >

using pcl::IntegralImage2D< DataType, 1 >::Ptr = shared_ptr<IntegralImage2D<DataType, 1> >

Definition at line 235 of file integral_image2D.h.

## SecondOrderType

template<class DataType >

using pcl::IntegralImage2D< DataType, 1 >::SecondOrderType = typename IntegralImageTypeTraits<DataType>::IntegralType

Definition at line 240 of file integral_image2D.h.

## Constructor & Destructor Documentation

## IntegralImage2D()

template<class DataType >

pcl::IntegralImage2D< DataType, 1 >::IntegralImage2D | ( | bool | compute_second_order_integral_images | ) |

inline

Constructor for an Integral Image.

Parameters

  [in] | compute_second_order_integral_images | set to true if we want to compute a second order image

Definition at line 245 of file integral_image2D.h.

## ~IntegralImage2D()

template<class DataType >

virtual pcl::IntegralImage2D< DataType, 1 >::~IntegralImage2D | ( |  | ) |

virtual default

Destructor.

## Member Function Documentation

## getFiniteElementsCount()

template<typename DataType >

unsigned pcl::IntegralImage2D< DataType, 1 >::getFiniteElementsCount | ( | unsigned | start_x,
|  | unsigned | start_y,
|  | unsigned | width,
|  | unsigned | height
| ) |  | const

inline

Compute the number of finite elements within a given rectangle.

Parameters

  [in] | start_x | x position of rectangle
  [in] | start_y | y position of rectangle
  [in] | width | width of rectangle
  [in] | height | height of rectangle

Definition at line 273 of file integral_image2D.hpp.

## getFiniteElementsCountSE()

template<typename DataType >

unsigned pcl::IntegralImage2D< DataType, 1 >::getFiniteElementsCountSE | ( | unsigned | start_x,
|  | unsigned | start_y,
|  | unsigned | end_x,
|  | unsigned | end_y
| ) |  | const

inline

Compute the number of finite elements within a given rectangle.

Parameters

  [in] | start_x | x position of the start of the rectangle
  [in] | start_y | x position of the start of the rectangle
  [in] | end_x | x position of the end of the rectangle
  [in] | end_y | x position of the end of the rectangle

Definition at line 315 of file integral_image2D.hpp.

## getFirstOrderSum()

template<typename DataType >

pcl::IntegralImage2D< DataType, 1 >::ElementType pcl::IntegralImage2D< DataType, 1 >::getFirstOrderSum | ( | unsigned | start_x,
|  | unsigned | start_y,
|  | unsigned | width,
|  | unsigned | height
| ) |  | const

inline

Compute the first order sum within a given rectangle.

Parameters

  [in] | start_x | x position of rectangle
  [in] | start_y | y position of rectangle
  [in] | width | width of rectangle
  [in] | height | height of rectangle

Definition at line 245 of file integral_image2D.hpp.

## getFirstOrderSumSE()

template<typename DataType >

pcl::IntegralImage2D< DataType, 1 >::ElementType pcl::IntegralImage2D< DataType, 1 >::getFirstOrderSumSE | ( | unsigned | start_x,
|  | unsigned | start_y,
|  | unsigned | end_x,
|  | unsigned | end_y
| ) |  | const

inline

Compute the first order sum within a given rectangle.

Parameters

  [in] | start_x | x position of the start of the rectangle
  [in] | start_y | x position of the start of the rectangle
  [in] | end_x | x position of the end of the rectangle
  [in] | end_y | x position of the end of the rectangle

Definition at line 287 of file integral_image2D.hpp.

## getSecondOrderSum()

template<typename DataType >

pcl::IntegralImage2D< DataType, 1 >::SecondOrderType pcl::IntegralImage2D< DataType, 1 >::getSecondOrderSum | ( | unsigned | start_x,
|  | unsigned | start_y,
|  | unsigned | width,
|  | unsigned | height
| ) |  | const

inline

Compute the second order sum within a given rectangle.

Parameters

  [in] | start_x | x position of rectangle
  [in] | start_y | y position of rectangle
  [in] | width | width of rectangle
  [in] | height | height of rectangle

Definition at line 259 of file integral_image2D.hpp.

## getSecondOrderSumSE()

template<typename DataType >

pcl::IntegralImage2D< DataType, 1 >::SecondOrderType pcl::IntegralImage2D< DataType, 1 >::getSecondOrderSumSE | ( | unsigned | start_x,
|  | unsigned | start_y,
|  | unsigned | end_x,
|  | unsigned | end_y
| ) |  | const

inline

Compute the second order sum within a given rectangle.

Parameters

  [in] | start_x | x position of the start of the rectangle
  [in] | start_y | x position of the start of the rectangle
  [in] | end_x | x position of the end of the rectangle
  [in] | end_y | x position of the end of the rectangle

Definition at line 301 of file integral_image2D.hpp.

## setInput()

template<typename DataType >

void pcl::IntegralImage2D< DataType, 1 >::setInput | ( | const DataType * | data,
|  | unsigned | width,
|  | unsigned | height,
|  | unsigned | element_stride,
|  | unsigned | row_stride
| ) |  |

Set the input data to compute the integral image for.

Parameters

  [in] | data | the input data
  [in] | width | the width of the data
  [in] | height | the height of the data
  [in] | element_stride | the element stride of the data
  [in] | row_stride | the row stride of the data

Definition at line 228 of file integral_image2D.hpp.

## Member Data Documentation

## second_order_size

template<class DataType >

const unsigned pcl::IntegralImage2D< DataType, 1 >::second_order_size = 1

static

Definition at line 238 of file integral_image2D.h.

The documentation for this class was generated from the following files:

- pcl/features/integral_image2D.h
- pcl/features/impl/integral_image2D.hpp